<?xml version="1.0" encoding="utf-8"?>
<Config>
    <Global>
        <FrontCamera>0</FrontCamera> <!-- 前置开关，前置设1，后置设0 -->
        <HDCCalibW>2304</HDCCalibW> <!-- v600字节标定没有存分辨率，需要指定 -->
        <HDCCalibH>1728</HDCCalibH> 
        <MainCameraID1>2</MainCameraID1> <!-- 双目第一组模组送显对应的cameraID-->
        <MainCameraID2>8</MainCameraID2> <!-- 双目第二组模组送显对应的cameraID-->
        <CameraID2FocalLengthFactor>2</CameraID2FocalLengthFactor> <!-- 视差转深度 fb 需要除以该系数(tele 镜头) 得到相对深度-->
    </Global>

    <AlgorithmPreprocessInfo>
        <distortionAlg enable="1">
            <brownEnable>1</brownEnable>        <!-- 0: disable 1: enable -->
            <bsplineEnable>1</bsplineEnable>    <!-- 0: disable 1: enable -->
        </distortionAlg>

        <OTPRectifyEnable>1</OTPRectifyEnable>     <!-- 0: disable 1: enable -->            

        <selfLearnAlg enable="1">           <!-- 0: disable 1: enable -->
            <!-- todo -->
        </selfLearnAlg>

        <brightnessColorAdjustEnable>1</brightnessColorAdjustEnable>
        <brightnessGrayAdajustEnable>1</brightnessGrayAdajustEnable>
        <onlineDistortionEnable>1</onlineDistortionEnable>
        <multipleOf8Enable>1</multipleOf8Enable>   <!-- 输入图宽高非8字节对齐校正，仅HL手机开启-->

        <matchNumThresh>500</matchNumThresh> 
        <nameFeaturePoint>/vendor/etc/camera/dcamera/cherry_feature.bin</nameFeaturePoint>       

    </AlgorithmPreprocessInfo>
    
    <AlgorithmDCInfo>
        <portraitSegmentAlg enable="1">     <!-- 0: disable 1: enable -->
            <modelWidth>451</modelWidth>
            <modelHeight>451</modelHeight>
            <modelPath>/vendor/etc/camera/cnnmodel/dualcamera/DualCamera_BC_PortraitSeg.om</modelPath>
            <isSoftmax>1</isSoftmax>
            <normData>0</normData> <!-- 0, 不归一化，1，只减均值， 2 减均值并除以255 -->
        </portraitSegmentAlg>

        <TwoPlaneAlgCfg enable="1">     <!-- 0: disable 1: enable -->
            <modelWidth>704</modelWidth>
            <modelHeight>704</modelHeight>
            <modelPath>/vendor/etc/camera/cnnmodel/dualcamera/PCTClas_withaug_5w.om</modelPath>
            <isSoftmax>1</isSoftmax>
            <normData>0</normData>
        </TwoPlaneAlgCfg>

        <mattingAlg enable="1">     <!-- 0: disable 1: enable -->
            <modelWidth>768</modelWidth>
            <modelHeight>768</modelHeight>
            <modelPath>/vendor/etc/camera/cnnmodel/dualcamera/matting.om</modelPath>
            <isSoftmax>0</isSoftmax>
            <normData>2</normData>
        </mattingAlg>

        <mattingSimpleAlg enable="1">     <!-- 0: disable 1: enable -->
            <modelWidth>208</modelWidth>
            <modelHeight>208</modelHeight>
            <modelPath>/vendor/etc/camera/cnnmodel/dualcamera/mattingSimple.om</modelPath>
            <isSoftmax>0</isSoftmax>
            <normData>2</normData>
        </mattingSimpleAlg>

        <mattingDetectAlg enable="1">     <!-- 0: disable 1: enable -->
            <modelWidth>224</modelWidth>
            <modelHeight>224</modelHeight>
            <modelPath>/vendor/etc/camera/cnnmodel/dualcamera/mattingDetect.om</modelPath>
            <isSoftmax>0</isSoftmax>
            <normData>2</normData>
        </mattingDetectAlg>

        <sparseDispAlg enable="1">          <!-- 0: disable 1: enable -->
            <DCEAlg enable="0">
                <baseConfig>
                    <ratio>1</ratio>    <!-- {1, 2} output resolution width/ratio-->
                    <lrcheckEnable>0</lrcheckEnable>
                </baseConfig>
                <externConfig enable="0">
                    <lrcheckEnable> 0 </lrcheckEnable>
                </externConfig>
            </DCEAlg>
            <DMAPAlg enable="1">
                <dmapVersion>3</dmapVersion>     <!--0:v150, 1:v160, 2:v200, 3:v250, ... 15:unknown-->
                <baseConfig>
                    <lrcheckEnable>1</lrcheckEnable>
                </baseConfig>
                <externConfig enable="1">
                    <lrcheckEnable>0</lrcheckEnable>
                </externConfig>
            </DMAPAlg>

            <sparseOptAlg> 
                <occOptEnable>1</occOptEnable>           <!-- 0: disable 1: enable -->
                <connectFillEnable>0</connectFillEnable> 
                <blackFillEnable>0</blackFillEnable>    <!-- 0: disable 1: enable -->
                <skyOptEnable>0</skyOptEnable>          <!-- 0: disable 1: enable -->
                <subPixelsEnable>0</subPixelsEnable>    <!-- hl always close -->
                <portraitMaskOptInterEnable>1</portraitMaskOptInterEnable>    
                <portraitMaskOptOuterEnable>0</portraitMaskOptOuterEnable>
                <portraitMaskOptHoleEnable>1</portraitMaskOptHoleEnable>
                <adpaptWithTofEnable>1</adpaptWithTofEnable>
		<adpaptBackWithTofEnable>1</adpaptBackWithTofEnable>
		<fillWithTofEnable>1</fillWithTofEnable>
            </sparseOptAlg>
        </sparseDispAlg>

        <denseDispAlg>
            <opticalFlowAlg>
                <ratio>1</ratio>                  <!-- {1, 2} output resolution width/ratio-->
                <occEnable>1</occEnable>            <!-- 0: disable 1: enable -->
                <headOptInterEnable>1</headOptInterEnable>    <!-- 0: disable 1: enable -->
                <headOptOuterEnable>0</headOptOuterEnable>    <!-- 0: disable 1: enable -->
            </opticalFlowAlg>

            <adaptureEnableHair>1</adaptureEnableHair> 

            <denseOptAlg>
                <fingerEnable>4</fingerEnable>            <!-- 0: disable 1 & other: Tradition, 2: Tradition & CNN, 3: CNN & Tradition, 4: CNN  -->
                <fingerSegType>0</fingerSegType>            <!-- 0: CNN Segment, 1: GMM   -->
                <fingerModelPath>/vendor/etc/camera/cnnmodel/dualcamera/DualCamera_BC_HandDetect.om</fingerModelPath>
                <fingerSegModelWidth>224</fingerSegModelWidth>
                <fingerSegModelHeight>224</fingerSegModelHeight>
                <fingerSegModelPath>/vendor/etc/camera/cnnmodel/dualcamera/DualCamera_BC_FingerSeg.om</fingerSegModelPath>
                <fingerSegIsSoftmax>1</fingerSegIsSoftmax>
                <fingerSegNormData>0</fingerSegNormData>
                <deburrEnable>1</deburrEnable>            <!-- 0: disable 1: enable -->
                <tofFrontCamera>0</tofFrontCamera>        <!-- 0: tof is rear camera 1: tof is front camera-->
                <tofGuideEnable>0</tofGuideEnable>            <!-- 0: disable 1: enable -->
                <tofModifyEnable>1</tofModifyEnable>            <!-- 0: disable 1: enable -->
                <portraitPlaneEnable>1</portraitPlaneEnable>    <!-- 0: disable 1: enable -->
                <cropAdaptEnable>1</cropAdaptEnable>
                <twoPlaneMode>1</twoPlaneMode>                          <!-- cherry -- //1:对概率值双边二值化 0:对深度值双边 -->
                <numTwoPlaneHoleThres>10</numTwoPlaneHoleThres>          <!-- cherry场景镂空数阈值 -->
                <fewHoleFrontVariance>57</fewHoleFrontVariance>          <!-- cherry场景少镂空时前景方差阈值 -->
                <fewHoleBackVariance>50</fewHoleBackVariance>            <!-- cherry场景少镂空时后景方差阈值 -->
                <manyHoleFrontVariance>110</manyHoleFrontVariance>        <!-- cherry场景多镂空时前景方差阈值 -->
                <manyHoleBackVariance>80</manyHoleBackVariance>            <!-- cherry场景多镂空时前景方差阈值 -->
                <fewHoleNotPortraitValidRatio>40</fewHoleNotPortraitValidRatio>               <!-- cherry场景少镂空时非人像稠密度阈值 -->
                <manyHoleNotPortraitValidRatio>30</manyHoleNotPortraitValidRatio>               <!-- cherry场景多镂空时非人像稠密度阈值 -->
                <cherry_seg_switch>1</cherry_seg_switch>                   <!-- cherry场景多镂空时非人像稠密度阈值 -->
                <SuperPortraitSwitch>1</SuperPortraitSwitch>                   <!-- 超级人像开关 -->
                <SPmodifyDispEnable>0</SPmodifyDispEnable>                   <!-- 超级人像修改视差开关 -->
                <SsimCoefThreshlod>0.64</SsimCoefThreshlod>                   <!-- 超级人像判断简单场景的ssim的阈值 -->
                <MattingDetectThres>0.996</MattingDetectThres>                   <!-- 超级人像场景检测网络阈值 -->
                <SsimVeryDifficultRatio>0.7</SsimVeryDifficultRatio>                   <!-- 超级人像ssim的难点占比阈值 -->
                <MattingExtendNumTh>4000</MattingExtendNumTh>                   <!-- 超级人像不同深度错点绝对值阈值 -->
                <railOptEnable>1</railOptEnable>    <!-- 0: disable 1: enable -->
            </denseOptAlg>
        </denseDispAlg>
    </AlgorithmDCInfo>

    <AlgorithmRFInfo>
        <frontFilterEnable>1</frontFilterEnable>        <!-- 0: disable 1: enable -->
        <edgeFilterEnable>1</edgeFilterEnable>          <!-- 0: disable 1: enable -->
        <blurEnhanceRatio>1.0</blurEnhanceRatio>                      <!--  [0.5, 2.0] -->
        <dofEnhanceRatio>1.0</dofEnhanceRatio>                       <!--  [0.5, 5.0] -->
        <spotTh>220</spotTh>                            <!--  [80, 255] -->
        <spotBrightnessEnhanceRatio>1.0</spotBrightnessEnhanceRatio>        <!--  [0.5, 5.0] -->
        <errorSpotOptEnable>1</errorSpotOptEnable>        <!-- 错误光斑检测-->
        <portraitBlurEnhanceRatio>1.0</portraitBlurEnhanceRatio>      <!--  [0.5, 2.0] -->
        <spotEnhanceEnable>1</spotEnhanceEnable>        

        <lowLightConnectAreaThRatio>70</lowLightConnectAreaThRatio>
        <outSideCircleConnectAreaThRatio>20</outSideCircleConnectAreaThRatio>
        <outSideOtherConnectAreaThRatio>40</outSideOtherConnectAreaThRatio>
        <srcWeightSwirlAndDiscsRatio>5</srcWeightSwirlAndDiscsRatio>
        <srcWeightHeartRatio>3</srcWeightHeartRatio>
        <portraitAutoAdjustFocusPointEnable>1</portraitAutoAdjustFocusPointEnable> <!--人像模式多人场景自动选择对焦人脸-->
        <noiseUniformEnable>1</noiseUniformEnable> <!--前后景噪声一致性-->
        <noiseUniformStrength>6</noiseUniformStrength> <!--噪声强度 [0, 10]-->
        <noiseUniformIsoTh>10</noiseUniformIsoTh> <!--iso阈值/10 [0, 255]-->
        <noiseWH>300</noiseWH>
        <noiseFile>/vendor/etc/camera/dcamera/noise.bin</noiseFile>
        <weightEnhanceCoefSpot>5</weightEnhanceCoefSpot> <!--光斑增强系数 [1, 30]-->
        <spotShapeAndContrastEnhanceEnable>1</spotShapeAndContrastEnhanceEnable> <!-- 0: disable 1: enable -->
        <dofEnhanceRatioAdaptiveEnabel>0</dofEnhanceRatioAdaptiveEnabel> <!--dof系数自适应-->
        <dofAdaptiveNearFocusDistanceThr>6</dofAdaptiveNearFocusDistanceThr> <!--近距离阈值[0,255]分米-->
        <dofAdaptiveFarFocusDistanceThr>20</dofAdaptiveFarFocusDistanceThr> <!--远距离阈值[0,255]分米-->
        <dofAdaptiveNearDofRatioThr>15</dofAdaptiveNearDofRatioThr> <!--近距离dof值[5,50]/10-->
        <dofAdaptiveFarDofRatioThr>10</dofAdaptiveFarDofRatioThr> <!--远距离dof值[5,50]/10-->
        <circleFilterFlareDilateR>7</circleFilterFlareDilateR> <!--光斑检测的腐蚀半径[3-10]-->
        <farFocusBlurEnhanceEnable>0</farFocusBlurEnhanceEnable> <!--主体离得远时虚化增强使能-->
        <optBlurStypeEnable>1</optBlurStypeEnable> <!--虚化风格-->
        <focusEdgeProcessEnable>1</focusEdgeProcessEnable> <!--对焦主体边缘处理-->
        <flaresColorOptEnable>1</flaresColorOptEnable> <!--光斑色彩优化-->
        <flaresColorOptCoef>25</flaresColorOptCoef> <!--光斑颜色饱和度系数[10~35]-->
        <flaresBrightnessCoef>18</flaresBrightnessCoef> <!--光斑亮度系数[1~25]-->
        <alphaEdgeSoftEnable>1</alphaEdgeSoftEnable> <!--alpha边缘平滑优化-->
        <perfectBokehEnable>1</perfectBokehEnable> <!--虚化美化处理-->
        <faceBCEnable>0</faceBCEnable> <!--FaceBC-->
        <blurStypeOfWA>0</blurStypeOfWA> <!--大光圈虚化风格控制-->
        
        <!-- backgroupAdj-->
        <bgadj>
            <contractAdjustEnable> 0 </contractAdjustEnable> <!-- 0:disable, 1 enable -->
            <colorAdjustEnable> 0 </colorAdjustEnable> <!-- 0:disable, 1 enable -->
            <lumaAdjustEnable> 0 </lumaAdjustEnable> <!-- 0:disable, 1 enable -->
            <bfRadius> 32 </bfRadius> <!-- BoxFilter radius-->
            <contractParam> 5 </contractParam>  <!-- Range:[0, 20] -->
            <lumaAdjustGain> -5 </lumaAdjustGain> <!-- Range:[-20, 20] -->
            <colorAdjRatio> 1.2 </colorAdjRatio> <!-- Range:[0.8f, 1.6f] -->
        </bgadj>

        <matButiAlg enable="1">     <!-- 0: disable 1: enable -->
            <modelWidth>768</modelWidth>
            <modelHeight>768</modelHeight>
            <modelPath>/vendor/etc/camera/cnnmodel/dualcamera/perfectBokehInterp.om</modelPath>
            <isSoftmax>0</isSoftmax>
            <normData>2</normData>
        </matButiAlg>

        <FaceBC enable="0">     <!-- 0: disable 1: enable -->
            <modelWidth>512</modelWidth>
            <modelHeight>512</modelHeight>
            <modelPath>/vendor/etc/camera/cnnmodel/dualcamera/enhance.om</modelPath>
        </FaceBC>
    </AlgorithmRFInfo>

    <ExternConfig>
        <packDispRefMatImg>0</packDispRefMatImg> <!-- 是否存储中间数据结果 dxo open, product close-->
    </ExternConfig>
</Config>
